<?php

class cfgmgr_DrupalSettingsConf extends cfgmgr_Conf {

  public $service = 'drupal';

  protected $cfg_registry = array(
    'db_host' => array(
      '#type' => 'ask',
      '#question' => 'What is the name of the database server?',
      '#default' => 'localhost',
    ),
    'db_driver' => array(
      '#type' => 'select',
      '#question' => 'What type of databse does Drupal use?',
      '#options' => array(
        array('!key' => 'pgsql', '!value' => 'PostgreSQL'),
        array('!key' => 'mysql', '!value' => 'MySQL'),
      ),
    ),
    'db_name' => array(
      '#type' => 'ask',
      '#question' => 'What is the name of the Database',
      '#default' => '!ns',
    ),
    'db_user' => array(
      '#type' => 'ask',
      '#question' => 'What is the username for the database user',
      '#default' => '!ns',
    ),
    'db_pass' => array(
      '#type' => 'ask',
      '#question' => 'What is the password for the database user? Leave blank for none.',
    ),
    'db_port' => array(
      '#type' => 'ask',
      '#question' => 'What is the database port? leave empty to assume default',
    ),
    'db_prefix' => array(
      '#type' => 'ask',
      '#question' => 'What is the prefix for the database? Leave empty for none.',
    ),
    'root' => array(
      '#type' => 'ask',
      '#question' => 'Where is the Drupal root?',
    ),
    'version' => array(
      '#type' => 'select',
      '#question' => 'Which version of Drupal is this project',
      '#options' => array(
        array('!key' => '6', '!value' => 'Drupal 6'),
        array('!key' => 7, '!value' => 'Drupal 7'),
      ),
    ),
    'sitedata' => array(
      '#type' => 'ask',
      '#question' => 'This configuration tool supports sitedata partions to symlink to sites/default/files and sites/default/cache. List the directory below are leave empty to disable',
      '#default' => '/var/lib/sitedata/!ns',
    ),
  );

  public function conf() {
    if (!$root = drush_get_option(array('r', 'root'))) {
      $root = $this->root;
    }
    if (!$settings = file_get_contents($root . '/sites/default/default.settings.php')) {
      return drush_set_error("Could not find default.settings.php in $root/sites/default file.");
    }
    if ($this->version >= 7) {
      $databases['default']['default'] = array(
        'driver' => $this->db_driver,
        'host' => $this->db_host,
        'username' => $this->db_user,
        'password' => $this->db_pass,
        'port' => $this->db_port,
        'prefix' => $this->db_prefix,
        'database' => $this->db_name,
      );
      $settings .= '$databases = ' . var_export($databases, TRUE) . ';' . PHP_EOL;
    }
    else {
      $settings .= '$db_url = "' . $this->db_driver . '://' . $this->db_user . ':' . $this->db_pass . '@' . $this->db_host . ':' . $this->db_port . '/' . $this->db_name . '";' . PHP_EOL;
      if ($this->db_prefix) {
        $settings .= '$db_prefix = "' . $this->db_prefix . '";';
      }
    }
    // Retrieve the sitedata value for service.setup.drupal.
    $this->sitedata;
    return $settings;
  }
}
